<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PointOfInterest ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PointOfInterest extends AbstractStructArrayBase
{
    /**
     * The PointOfInterest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PointOfInterest[]
     */
    public $PointOfInterest;
    /**
     * Constructor method for ArrayOfJP_PointOfInterest
     * @uses ArrayOfJP_PointOfInterest::setPointOfInterest()
     * @param \StructType\JP_PointOfInterest[] $pointOfInterest
     */
    public function __construct(array $pointOfInterest = array())
    {
        $this
            ->setPointOfInterest($pointOfInterest);
    }
    /**
     * Get PointOfInterest value
     * @return \StructType\JP_PointOfInterest[]|null
     */
    public function getPointOfInterest()
    {
        return $this->PointOfInterest;
    }
    /**
     * This method is responsible for validating the values passed to the setPointOfInterest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPointOfInterest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePointOfInterestForArrayConstraintsFromSetPointOfInterest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_PointOfInterestPointOfInterestItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PointOfInterestPointOfInterestItem instanceof \StructType\JP_PointOfInterest) {
                $invalidValues[] = is_object($arrayOfJP_PointOfInterestPointOfInterestItem) ? get_class($arrayOfJP_PointOfInterestPointOfInterestItem) : sprintf('%s(%s)', gettype($arrayOfJP_PointOfInterestPointOfInterestItem), var_export($arrayOfJP_PointOfInterestPointOfInterestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PointOfInterest property can only contain items of type \StructType\JP_PointOfInterest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PointOfInterest value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PointOfInterest[] $pointOfInterest
     * @return \ArrayType\ArrayOfJP_PointOfInterest
     */
    public function setPointOfInterest(array $pointOfInterest = array())
    {
        // validation for constraint: array
        if ('' !== ($pointOfInterestArrayErrorMessage = self::validatePointOfInterestForArrayConstraintsFromSetPointOfInterest($pointOfInterest))) {
            throw new \InvalidArgumentException($pointOfInterestArrayErrorMessage, __LINE__);
        }
        $this->PointOfInterest = $pointOfInterest;
        return $this;
    }
    /**
     * Add item to PointOfInterest value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PointOfInterest $item
     * @return \ArrayType\ArrayOfJP_PointOfInterest
     */
    public function addToPointOfInterest(\StructType\JP_PointOfInterest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PointOfInterest) {
            throw new \InvalidArgumentException(sprintf('The PointOfInterest property can only contain items of type \StructType\JP_PointOfInterest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PointOfInterest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PointOfInterest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PointOfInterest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PointOfInterest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PointOfInterest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PointOfInterest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PointOfInterest
     */
    public function getAttributeName()
    {
        return 'PointOfInterest';
    }
}
